#include "testlib.h"

std::string upper(std::string sa)
{
    for (size_t i = 0; i < sa.length(); i++)
        if ('a' <= sa[i] && sa[i] <= 'z')
            sa[i] = sa[i] - 'a' + 'A';
    return sa;
}

int main(int argc, char * argv[])
{
    setName("multiple CONNECTED or DISCONNECTED (case insensetive)");
    registerTestlibCmd(argc, argv);

    while (!ans.seekEof()) {
	    std::string ja = upper(ans.readWord());
	    std::string pa = upper(ouf.readWord());

	    if (pa != "CONNECTED" && pa != "DISCONNECTED")
		quitf(_pe, "CONNECTED or DISCONNECTED expected, but %s found", pa.c_str());

	    if (ja != "CONNECTED" && ja != "DISCONNECTED")
		quitf(_fail, "CONNECTED or DISCONNECTED expected in answer, but %s found", ja.c_str());

	    if (ja != pa)
		quitf(_wa, "expected %s, found %s", ja.c_str(), pa.c_str());
    }

    quitf(_ok, "");
}
