#include <cstdio>
#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <map>
#include <cstring>
#include <string>
#include <set>
#include <iomanip>
using namespace std;
typedef long long LL;
typedef pair<int,int> PII;
#define fname "disconnected."
#define pb push_back
#define F first
#define S second
#define mp make_pair
#define forit(it, s) for(__typeof(s.begin()) it = s.begin(); it != s.end(); it++)
#define all(s) s.begin(),s.end()
const int maxn = (int)1e5 + 100;
const int inf = (1 << 30) - 1;
const int magic = 350;
const int Bit = 61;

int n, R, v, u, k, c, pr[maxn], h[maxn], bad[maxn], ti, cnt, d[maxn], m[maxn], p[maxn], Cnt[maxn];
pair <pair<int, int>, int> s[maxn];
LL was[maxn / Bit][magic + 10];     

int Find(int v)
{
	if (pr[v] == v)
		return v;
	return pr[v] = Find(pr[v]);
}

void Union(int v, int u)
{
	v = Find(v);
	u = Find(u);
	if (h[v] > h[u])
		pr[u] = v;
	else
	{
		pr[v] = u;
		h[u] = max(h[v] + 1, h[u]);
	}
}

bool cmp(int p1, int p2) {
	if (Cnt[p1] < Cnt[p2])
		return true;
	return false;
}

int main()
{
	freopen(fname"in", "r", stdin);
	freopen(fname"out", "w", stdout);
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	srand(1341351);

	int *it, *it1, *it2;
	LL ul, *cur;
	

	cin >> n >> R;
	it = p;
	for (int i = 0; i < R; i++)
	{
		(*it) = i;
		cin >> v >> u;
		s[i] = mp(mp(u, v), i);
		++it;
	}

	it = d, it1 = m;

	for (int i = 0; i < maxn; ++i) {
		(*it) = i / Bit;
		(*it1) = i - (*it) * Bit;
		++it;
		++it1;
	}


	for (int T = 1; T <= magic; T++)
	{
		sort(p, p + R, cmp);
		it = pr + 1;
		it1 = h + 1;
		for (int i = 1; i <= n; i++) {
			(*it) = i, (*it1) = 0;
			++it, ++it1;
		}
		it2 = p;
		for (int i = 0; i < R; ++i)
		{
			if (Find(s[(*it2)].F.F) != Find(s[(*it2)].F.S))
			{
				Union(s[(*it2)].F.F, s[(*it2)].F.S);
				was[d[s[(*it2)].S]][T] |= (1ll << m[s[(*it2)].S]);
				++Cnt[(*it2)];
			}
			++it2;
		}
	}
	cin >> k;

	while (k--)
	{     
		cin >> c;
		++ti;
		cnt = 0;
		for (int j = 1; j <= c; j++)
		{
			cin >> v;
			v--;
			it = bad + 1;
			cur = was[d[v]] + 1;
			ul = (1ll << m[v]);
			for (int i = 1; i <= magic; i++)
			{
				if ((*it) != ti && ((*cur) & ul))
				{
					(*it) = ti;
					cnt++;
				}
				++it;
				++cur;
			}
	  	}
	  	if (cnt == magic)
  			cout << "Disconnected\n";
  	  	else
  	  		cout << "Connected\n";
  	}
	
	return 0;
}
