#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define sz(x) ((int) (x).size())
#define pb push_back
#define mp make_pair
#define fi first
#define se second

#define NAME "b"

int in[100001];
int up[100001];
int timer = 0;
bool used[100001];
bool bad[100001];
vector <int> g[100001];
vector <int> st;

vector <int> col[100001];
int COL;

void dfs(int u, int prev = -1)
{
	used[u] = true;
	up[u] = in[u] = timer++;
	st.pb(u);
	int bads = 0;
	for (int i = 0; i < sz(g[u]); ++i)
	{
		int v = g[u][i];
		if (v == prev)
			continue;
		if (used[v])
			up[u] = min(up[u], in[v]);
		else
		{
			dfs(v, u);
			up[u] = min(up[u], up[v]);
			bads += (up[v] >= in[u]);
			if (up[v] >= in[u] || prev == -1)
			{
//				cerr << u + 1 << ' ' << v + 1 << '\n';
				while (st.back() != u)
				{
					col[st.back()].pb(COL);
					st.pop_back();
				}
				col[u].pb(COL);
				++COL;
			}
		}
	}
	if ((prev != -1 && bads > 0) || bads > 1)
		bad[u] = true;
}

//vector<int> ofcol[

int check(int u, int v)
{
	if (sz(col[u]) > sz(col[v]))
		swap(u, v);
	for (int i = 0; i < sz(col[u]); ++i)
	{
		if (binary_search(col[v].begin(), col[v].end(), col[u][i]))
			return 1;
	}
	return 0;
}

int main()
{
	#ifdef LOCAL
	assert(freopen(NAME ".in", "r", stdin));
	#endif // LOCAL
	int n, m;
	cin >> n >> m;
	for (int i = 0; i < m; ++i)
	{
		int u, v;
		scanf("%d%d", &u, &v);
		--u, --v;
		g[u].pb(v);
		g[v].pb(u);
	}
	for (int i = 0; i < n; ++i)
		if (!used[i])
			dfs(i);
//	for (int i = 0; i < n; ++i)
//		if (bad[i])
//			cerr << i + 1 << ' ';
//	cerr << '\n';
//	for (int i = 0; i < n; ++i, cerr << '\n')
//		for (auto x: col[i])
//			cerr << x + 1 << ' ';
	int q, a, b;
	cin >> q >> a >> b;
	int ans = 0;
	for (int i = 0; i < q; ++i)
	{
//		cerr << a << ' ' << b << ' ';
		ans += check(a - 1, b - 1);
//		cerr << check(a - 1, b - 1) << '\n';
		int oldb = b;
		b = (13579ll * ll(a) + 97531ll * ll(b)) % ll(n) + 1;
		a = oldb;
	}
	cout << ans << '\n';
	#ifdef LOCAL
	cerr << "Time: " << double(clock()) / CLOCKS_PER_SEC << "\n";
	#endif // LOCAL
	return 0;
}
