
			int cq = min(BUBEN, q - i);
			memset(isRemoved, 0, sizeof(isRemoved));
			int bc = 0;
			for(int j = 0; j < cq; j++) {
				scanf("%d", &queriesSize[j]);
				for(int k = 0; k < queriesSize[j]; k++) {
					scanf("%d", &queriesIds[j][k]);
					--queriesIds[j][k];
					isRemoved[queriesIds[j][k]] = true;
					removedIds[bc++] = queriesIds[j][k];
				}
			}
			for(int j = 0; j < n; j++) {
				dsu[j] = j;
			}
			components = n;
			for(int j = 0; j < m; j++) {
				if(!isRemoved[j]) {
					dsuUnion(edges[j].first, edges[j].second);
				}
			}
			for(int j = 0; j < n; j++) {
				dsu[j] = dsuFind(j);
			}
			int bcGood = 0;
			for(int j = 0; j < bc; j++) {
				int edgeId = removedIds[j];
				if(dsuFind(edges[edgeId].first) != dsuFind(edges[edgeId].second)) {
					removedIdsGood[bcGood++] = edgeId;
				}
			}
			random_shuffle(removedIdsGood, removedIdsGood + bcGood);
			for(int j = 0; j < cq; j++) {
				//printf("QUERY: %d\n", j);
				int timer = i + j + 1;
				int componentsBefore = components;
				stackClear();
				for(int k = 0; k < queriesSize[j]; k++) {
					isRemovedCurrent[queriesIds[j][k]] = timer;
				}
				for(int k = 0; k < bcGood && components > 1; k++) {
					int minComponents = components - (bcGood - k);
					if(minComponents > 1) break;
					int edgeId = removedIdsGood[k];
					if(isRemovedCurrent[edgeId] != timer) {
						//printf("MERGE: %d %d\n", edges[edgeId].first, edges[edgeId].second);
						dsuUnionHistory(edges[edgeId].first, edges[edgeId].second);
					}
				}
				//printf("After: %d\n", components);
				stackReverse();
				results[i + j] = (components == 1);
				components = componentsBefore;
			}
		}
	}
	double total = double(clock() - start) / CLOCKS_PER_SEC;
	//cout << total << endl;
	for(int i = 0; i < q; i++) {
		if(results[i]) printf("Connected\n");
		else printf("Disconnected\n");
	}
	return 0;
}