#include <iostream>
#include <vector>
#include <algorithm>


using namespace std;


const int pls = 0;
const int mins = 1;
const int qwe = 2;
const int Z = 1e6;
const int M = 1e5;
const int N = 1e4;

int a[Z], b[Z], c[Z], last[M], x[M], y[M], r[N], f[N];

int ans;

vector<pair<pair<int,int>,int> >  stack;

void undo()
{
	pair<pair<int,int>,int> z = stack.back();
	stack.pop_back();
	if (z.second == -1) return;
	ans++;
	f[z.first.second] = z.first.second;
	if (z.second == 1) {
		r[z.first.first]--;
	}
}

int find(int x)
{
	while (f[x] != x)
		x = f[x];
	return x;
}

void add(int x, int y)
{
	x = find(x), y = find(y);
	if (x == y)
	{
		stack.push_back(make_pair(make_pair(0, 0), -1));
		return;
	}
	ans--;
	if (r[x] > r[y])
	{
		f[y] = x;
		stack.push_back(make_pair(make_pair(x, y), 0));
	} else if (r[y] > r[x]) {
		f[x] = y;
		stack.push_back(make_pair(make_pair(y, x), 0));
	} else {
		f[y] = x;
		r[x]++;
		stack.push_back(make_pair(make_pair(x, y), 1));
	}	
}

void solve(int l, int r)
{
	if (l == r - 1)
	{
		if (a[l] == qwe) {
				if (ans == 1) {
					cout << "Connected" << endl;
				} else {
					cout << "Disconnected" << endl;
				}
		}
		return;
	}
	int m = (l + r) / 2;
	int cnt = 0;
	for(int i = m; i < r; i++)
	{
		if (a[i] == mins && c[i] < l)
		{
			add(x[b[i]], y[b[i]]);
			cnt++;
		}
	}
	solve(l, m);
	for(;cnt>0;cnt--) undo();
		
	cnt = 0;
	for(int i = l; i < m; i++)
	{
		if (a[i] == pls && c[i] >= r)
		{
			add(x[b[i]], y[b[i]]);
			cnt++;
		}
	}
	solve(m, r);
	for(;cnt>0;cnt--) undo();
	
}

int main()
{
	int n, m;
	cin >> n >> m;
	for(int i = 0; i < n; i++)
	{
		f[i] = i;
		r[i] = 0;
	}
	ans = n;
	for(int i = 0; i < m; i++)
	{
		
		cin >> x[i] >> y[i];
		x[i]--, y[i]--;
		a[i] = pls;
		b[i] = i;
		last[i] = i;
	}
	int q;
	cin >> q;
	int cnt = m;
	for(int i = 0; i < q; i++)
	{
		int k;
		cin >> k;
		int h[k];
		for(int j = 0; j < k; j++)
		{
			cin >> h[j];
			h[j]--;
			a[cnt] = mins;
			b[cnt] = h[j];
			c[cnt] = last[h[j]];
			c[last[h[j]]] = cnt;
			cnt++;
		}
		a[cnt++] = qwe;
		for(int j = 0; j < k; j++)
		{
			a[cnt] = pls;
			b[cnt] = h[j];
			last[h[j]] = cnt;
			cnt++;
		}
	}
	for(int i = 0; i < m; i++)
	{
		a[cnt] = mins;
		b[cnt] = i;
		c[cnt] = last[i];
		c[last[i]] = cnt;
		cnt++;
	}
	
	solve(0, cnt);
	return 0;
}
