#include <iostream>
#include <vector>
#include <algorithm>
#include <cstdio>

using namespace std;

const int p = 10007;

int ans = 2;

int c[p], s[p];

bool vis[p][p];

int a[p];

void dfs(int x, int y)
{
	int x0 = x, y0 = y;
	vis[x][y] = true;
	int lx = x, ly = y;
	bool flag = false;
	c[x]++, c[y]++;
	int cnt = 2;
	while (true) {
		//cout << x << " " << y << endl;
		int z = (x * y) % p;
		c[z]++;
		cnt++;
		while (c[z] > s[z]) {
			cnt--;
			c[lx]--;
			int lz = (lx * ly) % p;
			lx = ly;
			ly = lz;
			if (lx == x0 && ly == y0) 
			{
				flag = true;
				break;
			}
		}
		if (flag) break;
		x = y;
		y = z;
		vis[x][y] = true;
		ans = max(ans, cnt);
		//cout << cnt << endl;
	}
}

int main()
{
	int n, cnt_zero = 0, cnt_one = 0, cnt_mns = 0, non_zero = 0;
	cin >> n;
	for(int i = 0; i < n; i++)
	{
		cin >> a[i];
		if (a[i] == 1) {
			cnt_one++;
		}
		if (a[i] == p - 1) {
			cnt_mns++;
		}
		if (a[i] != 0) {
			non_zero++;
		}
		if (a[i] == 0) {
			cnt_zero++;
		}
		s[a[i]]++;
	}
	
	for(int i = 0; i < n; i++)
	{
		for(int j = 0; j < n; j++)
		{
			if (i != j) {
				if (a[i] != 0 && a[j] != 0 && !((a[i]*a[i]) % p != 1 && (a[j] * a[j]) % p != 1)) {
					if (!vis[a[i]][a[j]])
					{
						for(int q = 0; q < p; q++)
						{
								c[q] = 0;
						}
						dfs(a[i], a[j]);
					}
				}
			}
		}
	}
	
	ans = max(ans, min(cnt_mns, cnt_one));
	ans = max(ans, cnt_zero + (non_zero != 0));
	
	cout << ans << endl;
	
	return 0;
}