#include <iostream>
#include <cstdio>
#include <set>
#include <map>
#include <queue>
#include <vector>
#include <fstream>
#include <sstream>
#include <algorithm>

#define forn(i, n) for (int i = 0; i < (int)(n); ++i)
#define for1(i, n) for (int i = 1; i <= (int)(n); ++i)
#define ford(i, n) for (int i = (int)(n) - 1; i >= 0; --i)
#define mp make_pair
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define fi first
#define se second

using namespace std;

typedef long long i64;
typedef unsigned long long u64;
typedef vector<int> vi;
typedef vector<i64> vi64;
typedef pair<int, int> pii;

const int MAXN = 20000, MAXM = 110000;
vector<pii> e[MAXN];
pii es[MAXM];
u64 z[MAXM], sc[MAXN];
int vis[MAXN];
bool te[MAXN];

int xx = 0;

u64 uniform() {
	u64 res = (1ULL << xx);
	xx = (xx + 1) % 64;
	return res;
	/*u64 res = 0;
	forn(i, 64) res <<= 1, res |= rand() & 1;
	return res;*/
}

void dfs(int v, int id) {
	if (vis[v]) return;
	vis[v] = 1;
	for (pii u: e[v]) {
		if (u.second == id) continue;
		if (vis[u.fi] == 0) {
			dfs(u.first, u.second);
			sc[v] ^= sc[u.first];
			te[u.second] = 1;
		}
		if (vis[u.fi] == 1) {
			z[u.second] = uniform();
			sc[v] ^= z[u.second];
			sc[u.first] ^= z[u.second];
		}
	}
	if (id != -1) z[id] = sc[v];
	vis[v] = 2;
}

int main() {
	ios::sync_with_stdio(false);
	freopen("disconnected.in", "rt", stdin);
	freopen("disconnected.out", "wt", stdout);
	int N, M;
	cin >> N >> M;
	forn(i, M) {
		int u, v;
		cin >> u >> v;
		--u; --v;
		e[u].pb(mp(v, i));
		e[v].pb(mp(u, i));
	}
	dfs(0, -1);
	
	int Q;
	cin >> Q;
	forn(q, Q) {
		int v;
		cin >> v;
		vi s(v);
		forn(i, v) {
			cin >> s[i];
			--s[i];
		}
		bool ok = false;
		forn(i, 1 << v) {
			if (!i) continue;
			u64 x = 0;
			forn(j, v) {
				if ((i >> j) & 1) x ^= z[s[j]];
			}
			if (!x) ok = true;
		}
		cout << (ok ? "Disconnected" : "Connected") << '\n';
	}

    return 0;
}
