#include <iostream>
#include <cstdio>
#include <set>
#include <memory.h>
#include <map>
#include <queue>
#include <vector>
#include <fstream>
#include <sstream>
#include <algorithm>
#include <cassert>
#include <ctime>
#include <cmath>
#include <string>
#include <bitset>

#define fore(i, a, b) for(int i = (int)(a); i <= (int)(b); ++i)
#define forn(i, n) for (int i = 0; i < (int)(n); ++i)
#define for1(i, n) for (int i = 1; i <= (int)(n); ++i)
#define ford(i, n) for (int i = (int)(n) - 1; i >= 0; --i)
#define all(x) (x).begin(), (x).end()
#define mp make_pair
#define pb push_back
#define fi first
#define se second

using namespace std;

typedef long double ld;
typedef long long i64;
typedef vector<int> vi;
typedef vector<i64> vi64;
typedef pair<int, int> pii;
typedef unsigned int u32;
typedef vector<pii> vpi;
typedef vector<vi> vvi;

const int N = 10007;
bitset<N-1> a[N-1];
int logs[N];
int pows[N-1];

template<class T> bool uax(T& a, const T& b) {
	if( a < b ) { a = b; return true; }
	return false;
}

inline int mul(int a, int b) {
    return a * b % N;
}

bool good(int g) {
    pows[0] = 1;
    forn(i, N-1) if( i ) pows[i] = mul(pows[i-1], g);
    set<int> sa(pows, pows + N-1);
    return sa.size() == N-1;
}

void gen_logs() {
    int g = 2;
    while( !good(g) )
        ++g;
//	cerr << g << '\n';
	pows[0] = 1;
    forn(i, N-1) if( i ) pows[i] = mul(pows[i-1], g);
    logs[0] = -1;
    forn(i, N-1) logs[pows[i]] = i; 
}

int ans;
int cnt[N];
int T[N*3];
int k;
int bcnt[N];

void go() {
	int n = k;
	while( n < 2*N + 10 ) {
		T[n] = T[n-k];
		++n;
	}
	int l = 0, r = 0;
	memset(bcnt, 0, sizeof bcnt);
	while( r < n ) {
		if( l == r ) {
			while( l < n && !cnt[T[l]] ) {
				++l;
				++r;
			}
		}
		while( r < n && bcnt[T[r]] < cnt[T[r]] ) {
			++bcnt[T[r]];
			++r;
		}
		uax(ans, r - l);
		--bcnt[T[l]];
		++l;
	}
	/*while( l < r ) {
		++bcnt[T[l]];
		++l;
	}*/
}


int main() {
#define TASK "death"
#ifdef HOME
    freopen(TASK".in", "r", stdin);
    freopen(TASK".out", "w", stdout);
#endif
	gen_logs();
	int _n = 10000;
	cin >> _n;
	int cntz = 0;
	forn(i, _n) {
		int x = 1;
		cin >> x;
		if( x == 0 ) ++cntz;
		else cnt[ logs[x] ] += 1;
	}
	ans = cntz + min(1, *max_element(cnt, cnt + N - 1));
	forn(_i, N-1) forn(_j, N-1) {
		int i = _i, j = _j;
		if( !a[i].test(j) ) {
			k = 0;
			T[k++] = i;
			T[k++] = j;
			do {
				a[i].set(j);
				int ni = i + j;
				if( ni >= N - 1 ) ni -= N - 1;
				i = j; j = ni;
				T[k++] = ni;
			}
			while( i != _i || j != _j );
			--k;
			--k;
			go();
		}
	}
	cout << ans << '\n';
#ifdef HOME
    cout << clock() * 1.0 / CLOCKS_PER_SEC << '\n';
#endif
    return 0;
}
