#include <bits/stdc++.h>

using namespace std;

#ifdef SG
	#include "debug/debug.h"
#else
	#define debug(...)
#endif

#define forn(i,n) for (int i = 0; i < int(n); ++i)
#define ford(i,n) for (int i = int(n) - 1; i >= 0; --i)

#define fs first
#define sc second
#define pb push_back
#define mp make_pair
#define ve vector
#define pa pair

#define all(a) (a).begin(), (a).end()
#define sz(a) int((a).size())

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;
typedef vector<int> vi;

template <typename T1, typename T2> bool umn (T1 & a, T2 b) {if (b < a) {a = b; return 1;} return 0;}
template <typename T1, typename T2> bool umx (T1 & a, T2 b) {if (a < b) {a = b; return 1;} return 0;}

const int N = 10007;

struct Input {
	int n;
	int a[N];
	
	bool read () {
		if (!(cin >> n)) {
			return 0;
		}
		forn (i, n) {
			scanf("%d", &a[i]);
		}
		return 1;
	}
	
	void init (Input const & input) {
		*this = input;
	}
};

struct Data: Input {
	int ans;
	
	void write () {
		cout << ans << endl;
	}
	
	virtual void solve () {}
	virtual void clear () {}
};

struct Solution: Data {
	static const int M = N - 1;
	
	short cnt[M];
	bool u[M][M];
	
	static const int K = 10010;
	
	short c[2 * K];
	
	short cnt1[M], cnt2[M];
	
	void calc (int s1, int s2) {
		short t1 = s1;
		short t2 = s2;
		int k = 0;
		do {
			c[k] = t1;
			u[t1][t2] = 1;
			swap(t1, t2);
			t2 += t1;
			if (t2 >= M) {
				t2 -= M;
			}
			k++;
		} while (t1 != s1 || t2 != s2);
		memcpy(c + k, c, k * sizeof(short));
		
		short *bound = c + k;
		for (short *it = c; it != bound; ++it) {
			cnt1[*it]++;
		}
		short Q = N;
		for (short *it = c; it != bound; ++it) {
			umn(Q, cnt[*it] / cnt1[*it]);
		}
		for (short *it = c; it != bound; ++it) {
			cnt2[*it] = cnt[*it] - Q * cnt1[*it];
		}
		for (short *it = c; it != bound; ++it) {
			cnt1[*it] = 0;
		}
		Q *= k;
		if (Q + k - 1 < ans) {
			return;
		}
		short *jt = c;
		for (short *it = c; it != bound; ++it) {
			while (cnt2[*jt]) {
				cnt2[*jt]--;
				jt++;
			}
			umx(ans, Q + jt - it);
			cnt2[*it]++;
		}
	}
	
	void solve1 () {
		memset(cnt, 0, sizeof cnt);
		memset(cnt1, 0, sizeof cnt1);
		forn (i, n) {
			cnt[a[i]]++;
		}
		memset(u, 0, sizeof u);
		vi q;
		forn (i, M) {
			q.pb(a[i]);
		}
		sort(all(q));
		q.erase(unique(all(q)), q.end());
		random_shuffle(all(q));
		forn (i, M) {
			if (clock() > CLOCKS_PER_SEC * 4.7) {
				return;
			}
			forn (j, M) {
				if (!u[q[i]][q[j]]) {
					calc(q[i], q[j]);
				}
			}
		}
	}
	
	static const int root = 5;
	int ln[N];
	
	void solve () {
		ans = 0;
		{
			sort(a, a + n);
			int k = 0;
			while (k < n && a[k] == 0) {
				++k;
			}
			umx(ans, k + (k < n));
			reverse(a, a + n);
			n -= k;
			if (!n) {
				return;
			}
		}
		
		{
			int t = 1;
			forn (i, N - 1) {
				ln[t] = i;
				t = t * root % N;
			}
			forn (i, n) {
				a[i] = ln[a[i]];
			}
		}
		
		solve1();
	}
	
	void clear () {
		*this = Solution();
	}
};

Solution sol;

int main () {
	cout.precision(20);
	cout.setf(ios::fixed | ios::showpoint);
#ifdef SG
	freopen("c.in", "r", stdin);
//	freopen("", "w", stdout);
	while (sol.read()) {
		int t1 = clock();
		sol.solve();
		sol.write();
		sol.clear();
		int t2 = clock();
		debug(t2 - t1);
	}
#else
	sol.read();
	sol.solve();
	sol.write();
#endif

	return 0;
}
