#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cassert>
#include <ctime>
#include <cstring>
#include <algorithm>
#include <iostream>
#include <set>
#include <map>
#include <vector>
#include <queue>
#include <deque>
using namespace std;
#define pb push_back
#define mp make_pair
#define sc second
#define fs first
#define int64 long long
#define ldb long double
#define sz(a) ((int) (a).size())

const int p = 10007;
const int MAXLEN = 50 * 1000;

bool used[p][p];
int num[p], num_cur[p];
int cycle[MAXLEN];


int main() {
	//assert(freopen("death.in", "r", stdin));
	//assert(freopen("death.out", "w", stdout));

	int n;
	cin >> n;

	int tmp;
	for (int i = 0; i < n; ++i) {
		cin >> tmp;
		num[tmp % p]++;
	}
	int ans = min(n, num[0] + 1);
	for (int i = 1; i < p; ++i) {
		for (int j = 1; j < p; ++j) {
			if (!used[i][j]) {
				int cur = 0, x = i, y = j;
				while (!used[x][y]) {
					used[x][y] = true, cycle[cur++] = x;
					int tmp = (x * y) % p;
					x = y, y = tmp;
				}
				for (int k = 0; k < n + 10; ++k)
					cycle[k + cur] = cycle[k];
				memcpy(num_cur, num, sizeof(num));
				for (int l = 0, r = 0; l < cur; ++l) {
					while (num_cur[cycle[r]] > 0)
						num_cur[cycle[r++]]--;
					ans = max(ans, r - l);
					num_cur[cycle[l]]++;
				}
			}
		}
	}
	cout << ans << endl;
	return 0;
}