#include <ctime>
#include <iostream> 
#include <cstdio> 
#include <map> 
#include <set> 
#include <algorithm> 
#include <cstdlib> 
#include <cstring>
#include <cassert>
#include <utility>
#include <vector>
#include <string>
#include <queue>

#define pb push_back
#define mp make_pair

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair< int, int > pii;
typedef vector< int > vi;

bool used[10007][10007];
int a[40000], b[40000];
int cntA[10500], cntC[10500];
int lg[10050];

int
main()
{
	//freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
		
	{
		int pw = 1;
		int curVal = 2;
		do {
			lg[curVal] = pw;
			curVal = curVal * 2 % 10007;
			++pw;
		} while (curVal != 2);
	}

	int n;
	scanf("%d", &n);
	for (int i = 0; i < 10007; ++i) {
		cntA[i] = cntC[i] = 0;
	}
	for (int i = 0; i < n; ++i) {
		int bb;
		scanf("%d", &bb);
		++cntA[bb];
	}
	int res = 0;
	if (cntA[0] > 0) {
		if (cntA[0] == n) {
			res = n;
		} else {
			res = cntA[0] + 1;
		}
	}
	{ // (1, 1)
		res = max(res, cntA[1]);
	}
	{ // (1, -1)
		int i = 1, j = 10006;
		int ii = i, jj = j; 
		//i = lg[i], j = lg[j];
		int c = 0; 
		while (!used[i][j]) {
			a[c++] = i;
			used[i][j] = 1; 			
			int tmp = j; 
			j = i * j % 10007;
			//j = (i + j) % 10006;
			i = tmp; 
		}
		i = ii, j = jj; 
		/*if (c == 0) {
			continue;
		}*/
		int mVal = n + 1;
		for (int id = 0; id < c; ++id) {
			cntC[a[id]]++;
			a[c + id] = a[id];
		}
		for (int id = 0; id < c; ++id) {
			mVal = min(mVal, cntA[a[id]] / cntC[a[id]]);
		}
		for (int id = 0; id < c; ++id) {
			cntA[a[id]] -= mVal;
		}
		int l = 0, r = 0;
		for (; l < c; ++l) {
			if (r < l) {
				r = l;
			}
			while (cntA[a[r]] != 0) {
				cntA[a[r]]--;
				++r;
			}
			/*if (res < (r - l) + mVal * c) {
				printf("%d %d %d\n", a[l], a[l + 1], (r - l) + mVal * c);
			}*/
			res = max(res, (r - l) + mVal * c);
			if (l < r) {
				cntA[a[l]]++;
			}
		}
		while (l < r) {
			cntA[a[l++]]++;
		}
		for (int id = 0; id < c; ++id) {
			cntA[a[id]] += mVal * cntC[a[id]];
		}
		for (int id = 0; id < c; ++id) {
			cntC[a[id]]--;
		}
	}
	{
		int i = 1;
		for (int j = 2; j < 10006; ++j) {
			if (used[i][j]) {
				continue;
			}
			int ii = i, jj = j; 
			//i = lg[i], j = lg[j];
			int c = 0; 
			while (!used[i][j]) {
				a[c++] = i;
				used[i][j] = 1; 			
				int tmp = j; 
				j = i * j % 10007;
				//j = (i + j) % 10006;
				i = tmp; 
			}
			i = ii, j = jj; 
			for (int id = 0; id < c; ++id) {
				cntC[a[id]]++;
				a[c + id] = a[id];				
			}
			int l = 0, r = 0;
			for (; l < c; ++l) {
				if (r < l) {
					r = l;
				}
				while (cntA[a[r]] != 0) {
					cntA[a[r]]--;
					++r;
				}
				res = max(res, (r - l));
				if (l < r) {
					cntA[a[l]]++;
				}
			}
			while (l < r) {
				cntA[a[l++]]++;
			}
			for (int id = 0; id < c; ++id) {
				cntC[a[id]]--;
			}
		}
	}
	for (int i = 2; i <= 10006; i++) {
		for (int j = 1; j <= 10006; j++) {
			if (used[i][j]) {
				continue;
			}
			int ii = i, jj = j; 
			//i = lg[i], j = lg[j];
			int c = 0; 
			while (!used[i][j]) {
				a[c++] = i;
				used[i][j] = 1; 			
				int tmp = j; 
				j = i * j % 10007;
				i = tmp; 
			}
			i = ii, j = jj;
			for (int id = 0; id < c; ++id) {
				cntC[a[id]]++;
				a[c + id] = a[id];				
			}
			int l = 0, r = 0;
			for (; l < c; ++l) {
				if (r < l) {
					r = l; //2
				}
				while (cntA[a[r]] != 0) {
					cntA[a[r]]--;
					++r;
				}
				res = max(res, (r - l));
				if (l < r) {
					cntA[a[l]]++;
				}
			}
			while (l < r) {
				cntA[a[l++]]++;
			}
			for (int id = 0; id < c; ++id) {
				cntC[a[id]]--;
			}
		}
	}
	printf("%d\n", res);
	fprintf(stderr, "Time: %.3lf\n", clock() * 1. / CLOCKS_PER_SEC);
	return 0;
}