#define _USE_MATH_DEFINES

#include <cstdio>
#include <iostream>
#include <string>
#include <cstring>
#include <cstdlib>
#include <iomanip>
#include <vector>
#include <queue>
#include <map>
#include <set>
#include <stack>
#include <bitset>
#include <algorithm>
#include <ctime>
#include <cassert>
#include <cmath>

using namespace std;

#define forn(i, n) for (int i = 0; i < int(n); ++i)
#define pb push_back
#define mp make_pair
#define sz(a) int(a.size())
#define all(a) a.begin(),a.end()

typedef long long li;
typedef long double ld;

typedef pair<int,int> pt;
#define ft first
#define sc second

const int INF = int(1e9);
const li INF64 = li(1e18);
const ld EPS = 1e-9;

int n;
const int N = 10007;
int t[N];

bool read() {
	if (!(cin >> n))
		return false;
	forn (i, n)
		cin >> t[i];
	return true;
}

int bp(int a, int b)
{
	if (b == 0)
		return 1;
	if (b & 1)
		return a * bp(a, b - 1) % N;
	return bp(a * a % N, b >> 1);
}

short dp[N][N];
short rev[N];

void solve() {
	for (int i = 1; i < N; ++i)
	{
		rev[i] = bp(i, N - 2);
		assert(rev[i] * i % N == 1);
	}

	int r = -1;
	short ans = 2;
	forn (i, n)
	{
		forn (j, r)
			dp[t[j]][t[r]] = max(dp[t[j]][t[r]], short(2));
		r++;
		int cur = t[i];
		if (t[i] != 0)
			for (int b = 1; b < N; ++b)
			{
				int a = cur * rev[b] % N;
				assert(a * b % N == cur);
				if (dp[a][b] && dp[a][b] + 1 > dp[b][cur])
					dp[b][cur] = dp[a][b] + short(1);
				ans = max(ans, dp[b][cur]);
			}
		else
		{
			forn (p, N)
			{
				int b = 0, a = p;
				if (dp[a][b] && dp[a][b] + 1 > dp[b][cur])
					dp[b][cur] = dp[a][b] + short(1);
				ans = max(ans, dp[b][cur]);
				if (a == b)
					continue;
				swap(a, b);
				if (dp[a][b] && dp[a][b] + 1 > dp[b][cur])
					dp[b][cur] = dp[a][b] + short(1);
				ans = max(ans, dp[b][cur]);
			}
		}
	}

	cout << ans << endl;
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else

#ifdef TASK_NAME
	freopen(TASK_NAME ".in", "r", stdin);
	freopen(TASK_NAME ".out", "w", stdout);
#endif

#endif

	while (read())
		solve();

	return 0;
}