#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <map>
#include <cstdlib>
#include <cstdio>
#include <stack>
#include <deque>
#include <queue>
#include <cmath>
#include <ctime>

#define md 10007
#define N (500)
#define prev(x) ((x) - ((x) & (-x)))
#define next(x) ((x) + ((x) & (-x)))
#define ll long long
#define ull unsigned long long
#define fst first
#define snd second

#ifdef WIN32
    #define I64 I64d
#else
    #define I64 lld
#endif // WIN32

using namespace std;
int n, m;
vector<pair<int, int> > a;
vector<vector<int> > q;
vector<int> qe;
bool f[20000];

void BruteForce() {
    for (int i = 0; i < q.size(); i++) {
        for (int j = 0; j < n + 1; j++) {
            f[j] = true;
        }
        qe.clear();
        qe.push_back(1);
        f[1] = false;
        int beg = 0;
        while (beg < qe.size()) {
            int curr = qe[beg];
            for (int j = 0; j < a.size(); j++) {
                bool f2 = false;
                for (int z = 0; z < q[i].size();z++) {
                    if (j == q[i][z] - 1) {
                        f2 = true;
                    }
                }
                if (a[j].first == curr && f2 == false) {
                    int newc = a[j].second;
                    if (f[newc] == true) {
                        qe.push_back(newc);
                        f[newc] = false;
                    }
                } else {
                    if (a[j].second == curr && f2 == false) {
                        int newc = a[j].first;
                        if (f[newc] == true) {
                            qe.push_back(newc);
                            f[newc] = false;
                        }
                    }
                }
            }
        beg++;
        }
        bool f1 = false;
        for (int i = 1; i <= n; i++) {
            if (f[i] == true) {
                cout << "Disconnected" << endl;
                f1 = true;
                break;
            }
        }
        if (f1 == false) {
            cout << "Connected" << endl;
        }
    }
}

int main() {
    #ifdef DEBUG
        freopen("input.txt", "r", stdin);
        //freopen("output.txt", "w", stdout);
    #else
        //freopen("input.txt", "r", stdin);
        //freopen("output.txt", "w", stdout);
    #endif // DEBUG
    cin >> n >> m;
    vector<int> temp;
    for (int i = 0; i < m; i++) {
        int x, y;
        cin >> x >> y;
        a.push_back(make_pair(x, y));
    }
    int c;
    cin >> c;
    for (int i = 0; i < c; i++) {
        int k;
        cin >> k;
        q.push_back(temp);
        for (int j = 0; j < k; j++) {
            int x;
            cin >> x;
            q[i].push_back(x);
        }
    }
    BruteForce();

    return 0;
}
