#include <iostream>
#include <cstdio>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <stack>
#include <queue>
#include <vector>
#include <cmath>
#include <algorithm>
#include <ctime>
#include <cstdlib>
#include <cassert>

using namespace std;
#define forn(i, n) for (int i = 0; i < n; ++i)
#define ALL(a) a.begin(), a.end()
#define X first
#define Y second
#define sz(a) ((int)a.size())
#define L(a) sz(a)
#define pb(a) push_back(a)
#define mp(a, b) make_pair(a, b)
#define ms(a) memset(a,0,sizeof(a))
#define ms1(a) memset(a,-1,sizeof(a))

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;

const double PI = 3.1415926535897932384626433832795;

const int MoD = 10007;
const int mod = 10006;


const int root = 5;

const int maxn = 10100;
int pw[maxn];
int lg[maxn];
vector<vector<bool> > seen(mod, vector<bool>(mod));

int cnt[maxn];

void getnext(int& x, int& y) {
	int z = x+y;
	if (z >= mod) z -= mod;
	x = y, y = z;
}

const int MAGIC = maxn*6;

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#else
	/*freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);*/
#endif
	
	int r = 1;
	for (int i = 0; i < MoD; ++i) {
		pw[i] = r;
		lg[pw[i]] = i;
		r = r*(ll)root%MoD;
	}
	
	int n; scanf("%d", &n);
	vector<int> a(n);
	int c0 = 0;
	forn(i, n) {
		scanf("%d", &a[i]);
		if (a[i] == 0) c0++;
		else cnt[lg[a[i]]]++;
	}
	int ans = 2;
	ans = max(ans, c0+(c0 != n));
	cnt[0] = 0;
	forn(i1, mod) forn(i2, mod) {
		if (seen[i1][i2]) continue;
		int a1 = i1;
		int b1 = i2;
		int a2 = i1;
		int b2 = i2;
		int l = 0;
		int r = 0;
		while (l < MAGIC) {
			while (cnt[a2]) seen[a2][b2] = 1, --cnt[a2], ++r, getnext(a2,b2);
			int curans = r-l;
			ans = max(ans, curans);
			while (l < r && cnt[a2] == 0) ++cnt[a1], ++l, getnext(a1,b1);
			if (l == r) break;
		}
		while (l < r) ++cnt[a1], ++l, getnext(a1,b1);
	}
	printf("%d\n", ans);
	return 0;
}
