#include <cstdio>
#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <map>
#include <cstring>
#include <string>
#include <set>
#include <iomanip>
using namespace std;
typedef long long LL;
typedef pair<int,int> PII;
#define fname "disconnected."
#define pb push_back
#define F first
#define S second
#define mp make_pair
#define forit(it, s) for(__typeof(s.begin()) it = s.begin(); it != s.end(); it++)
#define all(s) s.begin(),s.end()
const int maxn = (int)1e5 + 100;
const int inf = (1 << 30) - 1;
const int magic1 = 300;
const int magic2 = 300;
const int Bit = 61;

int n, R, v[maxn][6], u, k, c[maxn], pr[maxn], h[maxn], bad[maxn], ti, cnt, d[maxn], m[maxn], Cnt[maxn];
pair <pair<int, int>, int> s[maxn];
LL was[maxn / Bit][magic2 + 10];

int Find(int v)
{
	if (pr[v] == v)
		return v;
	return pr[v] = Find(pr[v]);
}

void Union(int v, int u)
{
	v = Find(v);
	u = Find(u);
	if (h[v] > h[u])
		pr[u] = v;
	else
	{
		pr[v] = u;
		h[u] = max(h[v] + 1, h[u]);
	}
}

bool cmp(pair <pair <int, int>, int> p1, pair <pair <int, int>, int> p2) {
	if (Cnt[p1.S] < Cnt[p2.S])
		return true;
	return false;
}

int main()
{
	freopen(fname"in", "r", stdin);
	freopen(fname"out", "w", stdout);

	srand(1341351);

	scanf("%d%d", &n, &R);

	pair <pair <int, int>, int> *pshka;
	pshka = s;

	for (int i = 0; i < R; i++)
	{
		scanf("%d%d", &v[i][0], &u);
		(*pshka) = mp(mp(u, v[i][0]), i);
		++pshka;
	}

	scanf("%d", &k);
	for (int i = 0; i < k; ++i) {
		scanf("%d", &c[i]);
		for (int j = 0; j < c[i]; ++j) {
			scanf("%d", &v[i][j]);
			Cnt[v[i][j]]++;
		}
	}

	int *it, *it1;
	LL ul, *cur, ost;
	it = d, it1 = m;
	ul = 0, ost = 0;
	
	for (int i = 0; i < maxn; ++i) {
		(*it) = ul;
		(*it1) = ost;
		++ost;
		if (ost == Bit)
			ost = 0;
		if (!ost)
			++ul;
		++it, ++it1;
	}

	int magic;

	magic = min(magic2, max(300, 10000000 / R));
	int Cur = (int)(magic * 0.7);

	for (int T = 1; T <= magic; T++)
	{    
		if (T <= Cur)
			random_shuffle(s, s + R);
		else
			sort(s, s + R, cmp);
		it = pr + 1;            
		it1 = h + 1;
		for (int i = 1; i <= n; i++) {
			(*it) = i, (*it1) = 0;
			++it, ++it1;
		}
		for (int i = 0; i < R; ++i)
		{
			if (Find(s[i].F.F) != Find(s[i].F.S))
			{
				Union(s[i].F.F, s[i].F.S);
				was[d[s[i].S]][T] |= (1ll << m[s[i].S]);
			}
		}
	}

	int cc, f;
	for (int i = 0; i < k; ++i)
	{     
		++ti;
		cnt = 0;
		f = 0;
		for (int j = 0; j < c[i]; j++)
		{
			v[i][j]--;
			it = bad + 1;
			cur = was[d[v[i][j]]] + 1;
			f = 0;
			ul = (1ll << m[v[i][j]]);
			for (int i = 1; i <= magic; i++)
			{
				if ((*it) != ti && ((*cur) & ul))
				{
					(*it) = ti;
					cnt++;
					cc++;
				}
				++it;
				++cur;
			}
	  	}
	  	if (cnt == magic)
  			cout << "Disconnected\n";
  	  	else
  	  		cout << "Connected\n";
  	}
	
	return 0;
}
