#include <set>
#include <map>
#include <queue>
#include <deque>
#include <vector>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <iostream>
#include <algorithm>
using namespace std;

#define left first
#define right second
#define pb push_back
#define mp make_pair
#define sz(a) ((int)a.size())
#define all(a) a.begin(), a.end()
#define ms(a, x) memset(a, x, sizeof a)
#define MAXN 200002
#define f first
#define s second

typedef long long ll;
typedef vector<int> vi;
typedef pair<int,int> pii;
typedef pair<pii, int> tri;

const int N = 1<<17;
const int inf = 1<<30;

int n, m;
pair <int, int> e[MAXN];
vector < pair<int, int> > g[MAXN];
vector <int> clear;
int a[MAXN];
int c[MAXN];
int d[MAXN];
int dd;
int cc;

inline bool in(int id)
{
	for (int i = 0; i < sz(clear); ++i)
		if (clear[i] == id)
			return 1;
	return 0;
}

int dfs(int v)
{
	c[v] = cc;
	int r = 1;
	for (int i = 0; i < sz(g[v]); ++i)
	{
		int v2 = g[v][i].f;
		int id = g[v][i].s;
		if (c[v2] != cc && !in(id))
		{
			d[id] = dd;
			r += dfs(v2);
		}
	}
	return r;
}


int dfs2(int v)
{
	c[v] = cc;
	int r = 1;
	for (int i = 0; i < sz(g[v]); ++i)
	{
		int v2 = g[v][i].f;
		int id = g[v][i].s;
		if (c[v2] != cc && !in(id))
			r += dfs2(v2);
	}
	return r;
}


int main() {
	#ifdef LOCAL
	freopen("a.in", "r", stdin);
	freopen("a.out", "w", stdout);
	#endif

	scanf("%d%d", &n, &m);
	for (int i = 0; i < m; ++i)
	{
		int v1, v2;
		scanf("%d%d", &v1, &v2);
		--v1, --v2;
		g[v1].pb(mp(v2, i));
		g[v2].pb(mp(v1, i));
		e[i] = mp(v1, v2);
	}

	int q;
	scanf("%d", &q);
	dd = 1;
	++cc;
	bool ok = dfs(0) == n;
	for (int i = 0; i < q; ++i)
	{
		int t;
		scanf("%d", &t);
		for (int j = 0; j < t; ++j)
		{
			scanf("%d", &a[j]);
			--a[j];
		}

		int v = -1;
		for (int j = 0; j < t; ++j)
			if (d[a[j]] == 1)
				v = e[a[j]].f;
		++cc;
		if (v == -1)
			puts(ok ? "Connected" : "Disconnected");
		else
		{
			clear.clear();
			for (int j = 0; j < t; ++j)
				clear.pb(a[j]);
			puts(dfs2(v) == n ? "Connected" : "Disconnected");
		}
	}

	return 0;
}
