#include <iostream>

using namespace std;

short timesatmoment[10007];
short mat[10007][10007];


void rec(int i, int j) {
	if (timesatmoment[i] == 0 || timesatmoment[j] == 0) return;
	if (i==j && timesatmoment[i] ==  1) return;
	if (mat[i][j] != 0) return;

	--timesatmoment[i];
	int tmp = (i*j) % 10007;
	rec(j, tmp);
	mat[i][j] = 1 + mat[j][tmp];
	++timesatmoment[i];
}


int main() {
	int n;
	for (int i=0;i<10007;++i) timesatmoment[i] = 0;
	for (int i=0;i<10007;++i) for (int j=0;j<10007;++j) mat[i][j] = 0;

	cin >> n;
	for (int i=0; i<n; ++i) {
		int c;
		cin >> c;
		++timesatmoment[c];
	}

	int max=0;
	for (int i=0; i<n; ++i) {
		for (int j=0; j<n; ++j) {
			if (mat[i][j]==0) {
				rec(i, j);
				if (max<mat[i][j]) max = mat[i][j];
			}
		}
	}
	cout << max << endl;
	cout.flush();

	//int t;cin>>t;
}