#include <bits/stdc++.h>

#define pb puah_back
#define mp make_pair
#define all(x) (x).begin(), (x).end()
#define x first
#define y second
#define in(n) int (n) = nxt()

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef int itn;
typedef pair<int, int> PII;

int nxt() {
    int res;
    scanf("%d", &res);
    return res;
}

const int V = 10000000;

int * sa[V];
int sb[V];

int sz = 0;

#define set bafdsjfjds

void set(int * x, int y) {
    sa[sz] = x;
    sb[sz] = *x;
    *x = y;
    sz++;
}

void rev(int version) {
    while (sz > version) {
        *sa[sz - 1] = sb[sz - 1];
        --sz;
    }
}
const int N = 100000;

int p[N];
int s[N];

inline int get(int v) {
    if (p[v] == v) {
        return v;
    }
    set(p + v, get(p[v]));
    return p[v];
}

int cnt;

inline void unite(int a, int b) {
    a = get(a);
    b = get(b);
    if (s[a] > s[b]) {
        swap(a, b);
    }
    if (a != b) {
        set(&cnt, cnt - 1);
        set(p + a, b);
        set(s + b, s[a] + s[b]);
    }
}

int A[N], B[N];

struct query {
    int type;
    int id;
    int l;
    int r;
};

query * ST[V];

int ans[N];

void rec(int l, int r, int L, int R) {
    if (l == r) {
        for (int k = L; k < R; ++k) {
            query * u = ST[k];
            if (u->type == 0 && u->l == l) {
                ans[u->r] = cnt;
            }
        }
        return;
    }
    int ver = sz;
    int L1 = R;
    int R1 = L1;
    for (int k = L; k < R; ++k) {
        query * u = ST[k];
        if (u->type == 0) {
            if (u->l >= l && u->l <= r) {
                ST[R1++] = u;
            }
        } else {
            if (u->l > r) continue;
            if (u->l < l && u->r > r) continue;
            ST[R1++] = u;
        }
    }
    int mid = (l + r) / 2;
    for (int k = L1; k < R1; ++k) {
        query * u = ST[k];
        if (u->type == 1) {
            if (u->l < l && u->r > mid) {
                unite(A[u->id], B[u->id]);
            }
        }
    }
    rec(l, mid, L1, R1);
    rev(ver);
    for (int k = L1; k < R1; ++k) {
        query * u = ST[k];
        if (u->type == 1) {
            if (u->l <= mid && u->r > r) {
                unite(A[u->id], B[u->id]);
            }
        }
    }
    rec(mid + 1, r, L1, R1);
    rev(ver);
}

void solve(){
    in(n); in(m);
    for (int i = 0; i < n; ++i) {
        p[i] = i;
        s[i] = 1;
    }
    cnt = n;
    for (itn i = 0; i < m; ++i) {
        A[i] = nxt() - 1;
        B[i] = nxt() - 1;
    }
    int last[m];
    for (int i = 0; i < m; ++i) {
        last[i] = 0;
    }
    in(q);
    int SZ = 0;
    int tm = 1;
    for (int i = 0; i < q; ++i) {
        in(c);
        vector <int> ids;
        while (c--) {
            ids.push_back(nxt() - 1);
        }
        for (int j = 0; j < (int)ids.size(); ++j) {
            ST[SZ++] = new query{1, ids[j], last[ids[j]], tm++};
        }
        ST[SZ++] = new query{0, -1, tm++, i};
        for (int j = 0; j < (int)ids.size(); ++j) {
            last[ids[j]] = tm;
        }
        tm++;
    }
    for (int i = 0; i < m; ++i) {
        ST[SZ++] = new query{1, i, last[i], tm++};
    }
//    for (query x : Q) {
//        cout << x.type << " " << x.id << " " << x.l << " " << x.r << endl;
//    }
    rec(0, tm - 1, 0, SZ);
    for (int i = 0; i < q; ++i) {
        if (ans[i] != 1) {
            puts("Disconnected");
        } else {
            puts("Connected");
        }
    }
}

int main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL


    solve();

    return 0;
}
