#include <bits/stdc++.h>

using namespace std;

const int MAXN = 1e4 + 4;

int parent[MAXN], sz[MAXN];

int get(int v)
{
    if(v == parent[v]) return v;
    return parent[v] = get(parent[v]);
}

bool uni(int a, int b)
{
    a = get(a);
    b = get(b);
    if(a == b) return 0;
    if(sz[a] > sz[b]) swap(a, b);
    parent[a] = b;
    sz[b] += sz[a];
    return 1;
}

struct edge
{
    int v, u, num;
};

bool operator < (edge a, edge b)
{
    return a.v < b.v;
}

main()
{
    //freopen("input.txt", "r", stdin);
    ios::sync_with_stdio(0);
    cin.tie(0);
    srand(432);
    int n, m;
    cin >> n >> m;
    edge E[m];
    for(int i = 0; i < m; i++)
    {
        E[i].num = i;
        cin >> E[i].v >> E[i].u;
    }
    int MAXK = max(150, 1000000 / m);
    int K = MAXK;
    vector<int> tr[m];
    sort(E, E + m);
    while(K--)
    {
        for(int i = 0; i <= n; i++)
            parent[i] = i;
        for(int i = 0; i < m; i++)
            if(uni(E[i].v, E[i].u))
                tr[E[i].num].push_back(K);
        random_shuffle(E, E + m);
    }
    int q;
    cin >> q;
    while(q--)
    {
        int t;
        cin >> t;
        vector<int> res;
        while(t--)
        {
            int c;
            cin >> c;
            for(int i = 0; i < tr[c - 1].size(); i++) res.push_back(tr[c - 1][i]);
        }
        sort(res.begin(), res.end());
        res.resize(unique(res.begin(), res.end()) - res.begin());
        if(res.size() == MAXK) cout << "Disconnected\n";
        else cout << "Connected\n";
    }
    return 0;
}
