#include <bits/stdc++.h>

using namespace std;

vector<int> h, minh;

void dfs(int x, int p, vector<vector<int>> &G, vector<int> &in, vector<int> &out, int &t, int H = 1)
{
    if(h[x]) return;
    in[x] = t++;
    h[x] = minh[x] = H;
    for(auto it: G[x])
    {
        if(p == it) continue;
        dfs(it, x, G, in, out, ++t, H + 1);
        minh[x] = min(minh[x], minh[it]);
    }
    out[x] = ++t;
}

main()
{
    freopen("input.txt", "r", stdin);
    ios::sync_with_stdio(0);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    vector<vector<int>> G(n);
    while(m--)
    {
        int a, b;
        cin >> a >> b;
        G[a - 1].push_back(b - 1);
        G[b - 1].push_back(a - 1);
    }
    int q, a, b;
    cin >> q >> a >> b;
    h.assign(n, 0);
    minh.assign(n, 0);
    int t = 0;
    vector<int> in(n), out(n);
    dfs(n - 1, -1, G, in, out, t);
    int ans = 0;
    vector<int> B(q), A(q);
    A[0] = a;
    B[0] = b;
    for(int i = 0; i < q; i++)
    {
        a = A[i];
        b = B[i];
        if(a == b) ans++;
        else if(in[a - 1] < in[b - 1] && out[a - 1] > out[b - 1])
        {
            if(minh[b - 1] <= h[a - 1]) ans++;
        }
        else if(in[a - 1] > in[b - 1] && out[a - 1] < out[b - 1])
        {
            if(minh[a - 1] <= h[b - 1]) ans++;
        }
            if(i+ 1 == q) break;
        A[i + 1] = B[i];
        B[i + 1] = (13579 * A[i] + 97531 * B[i]) % (n + 1);
    }
    cout << q - ans << "\n";
    return 0;
}
