#include <bits/stdc++.h>

using namespace std;

#ifdef SG
	#include "debug/debug.h"
#else
	#define debug(...)
#endif

#define forn(i,n) for (int i = 0; i < int(n); ++i)
#define ford(i,n) for (int i = int(n) - 1; i >= 0; --i)

#define fs first
#define sc second
#define pb push_back
#define mp make_pair
#define ve vector
#define pa pair

#define all(a) (a).begin(), (a).end()
#define sz(a) int((a).size())

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;
typedef vector<int> vi;

template <typename T1, typename T2> bool umn (T1 & a, T2 b) {if (b < a) {a = b; return 1;} return 0;}
template <typename T1, typename T2> bool umx (T1 & a, T2 b) {if (a < b) {a = b; return 1;} return 0;}

const int N = 10100;
const int K = 100100;
const int SZ = 160;

struct Input {
	int n, m;
	int q;
	vector <pair<int, int> > e;
	vector <int> c[K];
	
	bool read () {
		if (scanf ("%d %d", &n, &m) != 2)
			return 0;
		forn(i, m) {
			int u, v;
			scanf ("%d %d", &u, &v);
			u--, v--;
			e.pb(mp(u, v));
		}
		scanf ("%d", &q);
		forn(i, q) {
			int kol;
			scanf ("%d", &kol);
			forn(j, kol) {
				int u;
				scanf ("%d", &u);
				u--;
				c[i].pb(u);
			}	
		}	
		return 1;
	}
	
	void init (Input const & input) {
		*this = input;
	}
};

struct Data: Input {
	bool ans[K];
	
	void write () {
		forn(i, q) {
			if (ans[i]) {
				puts("Connected");
			} else {
				puts("Disconnected");
			}
		}
	}
	
	virtual void solve () {}
	virtual void clear () {}
};

struct Solution: Data {

	bool use[K];
	int rnd;
	int p[N];
	int p2[N];
	
	inline int get (int a) {
		if (a == p[a])
			return a;
		return p[a] = get(p[a]);
	}
	
	inline bool uni (int l, int r) {
		l = get(l), r = get(r);
		if (l == r)
			return 0;
		if (rnd ^= 1)
			swap(l, r);
		p[l] = r;
		return 1;
	}
	
	inline int get2 (int a) {
		if (a == p2[a])
			return a;
		return p2[a] = get2(p2[a]);
	}
	
	inline bool uni2 (int l, int r) {
		l = get2(l), r = get2(r);
		if (l == r)
			return 0;
		if (rnd ^= 1)
			swap(l, r);
		p2[l] = r;
		return 1;
	}
	
	int idx[4 * SZ];
	int sz;
	int help[N];
	int kol;
	
	void solve () {
		rnd = 0;
		for (int i = 0; i < q; i += SZ) {
			sz = kol = 0;
			int r = min(q, i + SZ);
			memset(use, 0, sizeof(use));
			forn(j, n)
				p[j] = j;
			for (int j = i; j < r; ++j) {
				forn(k, c[j].size()) {
					if (!use[c[j][k]]) { 
						idx[sz++] = c[j][k];
						use[idx[sz - 1]] = 1;
					}
				}
			}
			forn(j, e.size()) {
				if (!use[j]) {
					uni(e[j].fs, e[j].sc);		
				}	
			}
			memset(use, 0, sizeof(use));
			forn(j, n) { 
				get(j);
				p2[j] = p[j];
			}
			forn(j, n) {
				if (p[j] == j) {
					help[kol++] = j;									
				}
			}
			for (int j = i; j < r; ++j) {
				forn(k, c[j].size()) {
					use[c[j][k]] = 1;	
				}
				int kol1 = 0;
				forn(k, sz) {
					int to = idx[k];
					if (!use[to]) {
						kol1 += uni2(p[e[to].fs], p[e[to].sc]);							
					}	
				}
				if (kol - kol1 == 1) {
					ans[j] = 1;
				} else {
					ans[j] = 0;
				}
				forn(k, kol) {
					p2[help[k]] = help[k];
				}
				forn(k, c[j].size()) {
					use[c[j][k]] = 0;	
				}	
			}	
		}
	}
	
	void clear () {
		*this = Solution();
	}
};

Solution sol;

int main () {
	cout.precision(20);
	cout.setf(ios::fixed | ios::showpoint);
#ifdef SG
	freopen("input.txt", "r", stdin);
//	freopen("", "w", stdout);
	while (sol.read()) {
		sol.solve();
		sol.write();
		sol.clear();
	}
#else
	while (sol.read()) {
		sol.solve();
		sol.write();
		sol.clear();
	}
#endif


	return 0;
}
