#include <bits/stdc++.h>

using namespace std;

#ifdef SG
	#include "debug/debug.h"
#else
	#define debug(...)
#endif

#define forn(i,n) for (int i = 0; i < int(n); ++i)
#define ford(i,n) for (int i = int(n) - 1; i >= 0; --i)

#define fs first
#define sc second
#define pb push_back
#define mp make_pair
#define ve vector
#define pa pair

#define all(a) (a).begin(), (a).end()
#define sz(a) int((a).size())

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef pair<int, int> pii;
typedef vector<int> vi;

template <typename T1, typename T2> bool umn (T1 & a, T2 b) {if (b < a) {a = b; return 1;} return 0;}
template <typename T1, typename T2> bool umx (T1 & a, T2 b) {if (a < b) {a = b; return 1;} return 0;}

const int N = 100000;

struct Input {
	int n;
	vi e[N];
	int q, r1, r2;
	
	bool read () {
		int m;
		if (!(cin >> n >> m)) {
			return 0;
		}
		forn (i, m) {
			int x, y;
			scanf("%d%d", &x, &y);
			--x;
			--y;
			e[x].pb(y);
			e[y].pb(x);
		}
		cin >> q >> r1 >> r2;
		return 1;
	}
	
	void init (Input const & input) {
		*this = input;
	}
};

struct Data: Input {
	int ans;
	
	void write () {
		cout << ans << endl;
	}
	
	virtual void solve () {}
	virtual void clear () {}
};

struct Solution: Data {
	static const int K = N * 3 + 100;
	int k;
	int pr[K];
	vi son[K];
	
	bool u[N];
	
	int up[N], tIn[N], ct;
	
	int dfs (int v) {
		tIn[v] = ct++;
		u[v] = 1;
		up[v] = tIn[v];
		int cur = k;
		pr[v] = cur;
		son[cur].pb(v);
		k++;
		forn (i, sz(e[v])) {
			int w = e[v][i];
			if (!u[w]) {
				debug(mp(v, w));
				int aaa = dfs(w);
				umn(up[v], up[w]);
				if (up[w] >= tIn[v]) {
					pr[aaa] = v;
					son[v].pb(aaa);
				} else {
					debug(mp("", mp(v, w)));
					if (sz(son[aaa]) < sz(son[cur])) {
						forn (i, sz(son[aaa])) {
							pr[son[aaa][i]] = cur;
						}
						son[cur].insert(son[cur].end(), all(son[aaa]));
						son[aaa] = vi();
					} else {
						forn (i, sz(son[cur])) {
							pr[son[cur][i]] = aaa;
						}
						son[aaa].insert(son[aaa].end(), all(son[cur]));
						son[cur] = vi();
						cur = aaa;
					}
				}
			}
			else {
				umn(up[v], tIn[w]);
			}
		}
		return cur;
	}
	
	static const ll A = 13579;
	static const ll B = 97531;
	
	void solve () {
		k = n;
		memset(u, 0, sizeof u);
		ct = 0;
		forn (i, n) {
			if (!u[i]) {
				int aaa = dfs(i);
				pr[aaa] = -1;
			}
		}
		debug(up, up + n);
		debug(tIn, tIn + n);
		debug(pr, pr + k);
		ans = 0;
		forn (i, q) {
			--r1;
			--r2;
			debug(mp(r1, r2));
			
			int md = -1;
			if (pr[r1] == pr[r2]) {
				md = pr[r1];
			} else if (pr[pr[r1]] == r2) {
				md = pr[r1];
			} else if (pr[pr[r2]] == r1) {
				md = pr[r2];
			}
			
			debug(md);
			
			ans += (md != -1);
			
			++r1;
			++r2;
			
			swap(r1, r2);
			r2 = (A * r2 + B * r1) % n + 1;
		}
	}
	
	void clear () {
		*this = Solution();
	}
};

Solution sol;

int main () {
	cout.precision(20);
	cout.setf(ios::fixed | ios::showpoint);
#ifdef SG
	freopen("b.in", "r", stdin);
//	freopen("", "w", stdout);
	while (sol.read()) {
		sol.solve();
		sol.write();
		sol.clear();
	}
#else
	sol.read();
	sol.solve();
	sol.write();
#endif
	return 0;
}
