#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cassert>
#include <ctime>
#include <cstring>
#include <algorithm>
#include <iostream>
#include <set>
#include <map>
#include <vector>
#include <queue>
#include <deque>
using namespace std;
#define pb push_back
#define mp make_pair
#define sc second
#define fs first
#define int64 long long
#define ldb long double
#define sz(a) ((int) (a).size())

const int p = 10007;
const int MAXLEN = 50 * 1000;

bool used[p][p];
int num[p], num_cur[p];
int cycle[MAXLEN];


int main() {
	assert(freopen("death.in", "r", stdin));
	assert(freopen("death.out", "w", stdout));

	int n;
	cin >> n;

	int tmp;
	for (int i = 0; i < n; ++i) {
		cin >> tmp;
		num[tmp]++;
	}

	int ans = min(n, num[0] + 1);
	for (int i = 1; i < p; ++i) {
		for (int j = 1; j < p; ++j) {
			if (!used[i][j]) {
				used[i][j] = true;
				int x = j;
				int y = (i * j) % p;

				int cur = 2;
				cycle[0] = i;
				cycle[1] = j;

				while (x != i || y != j) {
					used[x][y] = true;
					cycle[cur++] = y;
				
					tmp = (x * y) % p;
					x = y;
					y = tmp;
				}
				cur--;
				
				for (int k = 0; k < cur + n + 10; ++k) {
					cycle[k + cur] = cycle[k];
				}

				for (int k = 0; k < p; ++k) {
					num_cur[k] = num[k];
				}

				int l = 0;
				int r = 0;

				while (l != cur) {
					while (num_cur[cycle[r]] > 0) {
						num_cur[cycle[r]]--;
						r++;
					}

					ans = max(ans, r - l);
					
					if (r > l) {
						num_cur[cycle[l]]++;
					} else {
						r++;
					}

					l++;
				}
			}
		}
	}

	cout << ans << endl;

	return 0;
}