#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <cstring>
#include <cassert>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <stack>
#include <queue>
#include <deque>
#include <complex>

using namespace std;

#define pb push_back
#define mp make_pair
#define sz(s) int((s).size())
#define len(s) int((s).size())
#define all(s) (s).begin(), (s).end()
#ifdef _WIN32
#define LLD "%I64d"
#else
#define LLD "%lld"
#endif
#ifdef LOCAL42
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#else
#define eprintf(...) 42
#endif
#define y0 yy0
#define y1 yy1
#define next _next
#define prev _prev
#define rank _rank
#define link _link
#define hash _hash
#define fs first
#define sc second

typedef long long ll;
typedef long long llong;
typedef long long int64;
typedef unsigned int uint;
typedef long double ld;
typedef unsigned long long ull;
typedef unsigned long long ullong;
typedef unsigned long long lint;
typedef pair<int, int> pii;
typedef vector<int> vi;

const int inf = int(1e9);
const double eps = 1e-9;
const double pi = 4 * atan(double(1));
const int MOD = 10007;

bool ex[MOD];
int cnt[MOD], num[MOD], val[MOD];
bool used[MOD][MOD];
vector<pii> lst;

int main() {
#ifdef LOCAL42
#define TASK "C"
	freopen(TASK ".in", "r", stdin);
	freopen(TASK ".out", "w", stdout);
#else

#endif
	
	int cur = 1, al = 5;
	for (int i = 0; i < MOD - 1; ++i) {
		num[cur] = i;
		val[i] = cur;
		cur = (cur * al) % MOD;
	}

	int n;
	scanf("%d", &n);
	int zeros = 0;
	for (int i = 0; i < n; ++i) {
		int cur;
		scanf("%d", &cur);
		if (cur == 0) {
			zeros++;
			continue;
		}
		cnt[num[cur]]++;
	}
	int ans = 0;
	for (int i = 0; i < MOD - 1; ++i) {
		for (int j = 0; j < MOD - 1; ++j) {
			if (used[i][j]) {
				continue;
			}
			int x = i, y = j;
			used[x][y] = true;
			lst.clear();
			lst.pb(mp(x, y));
			for (;;) {
				int nx = y, ny = x + y;
				if (ny >= MOD - 1) {
					ny -= MOD - 1;
				}
				if (used[nx][ny]) {
					break;
				}
				x = nx;
				y = ny;
				used[x][y] = true;
				lst.pb(mp(x, y));
			}
			int cur = 0, h = 0;
			for (int z = 0; z < sz(lst); ++z) {
				if (cur == 0) {
					h = z;
				}
				while (cnt[lst[h].fs] > 0) {
					--cnt[lst[h++].fs];
					++cur;
					if (h >= sz(lst)) {
						h = 0;
					}
				}
				ans = max(ans, cur);
				if (cur > 0) {
					++cnt[lst[z].fs];
					--cur;
				}
			}
			while (cur > 0) {
				int ph = h - 1;
				if (ph < 0) {
					ph = sz(lst) - 1;
				}
				++cnt[lst[ph].fs];
				--cur;
				h = ph;
			}
		}
	}
	ans = max(ans, min(zeros + 1, n));
	cout << ans << endl;
	cerr << 1.0 * clock() / CLOCKS_PER_SEC << endl;
	return 0;
}
