#include <stdio.h>
#include <iostream>
#include <vector>

using namespace std;

#define rank rankrankrank

const int N = 500500;

int n, m, ss[N], ff[N], cnt, pred[N], rank[N], qqq, used[N], k, was[N];
bool ans[N];
vector<pair<int, int>> v;
vector<int> act;
vector<pair<int, pair<int, int>>> way;

void set_p(int x, int y) {
	way.push_back(make_pair(0, make_pair(x, pred[x])));
	pred[x] = y; 
}

void set_r(int x, int val) {
	way.push_back(make_pair(1, make_pair(x, rank[x])));
	rank[x] = val;
}

int fs(int x) {
	if (pred[x] != x) {
		return fs(pred[x]);
	}
	return pred[x];
}

void add(int x, int y) {
	x = fs(x);
	y = fs(y);
	if (x == y) return;
	--cnt;
	if (rank[x] > rank[y]) swap(x, y);
	set_p(x, y);
	if (rank[x] == rank[y]) set_r(y, rank[y] + 1);
}

void solve(int l, int r) {
	if (l + 1 == r) {
		if (v[l].first == 0) {
			ans[v[l].second] = cnt == 1;
		}
		return;
	}
	int mid = (l + r) / 2;
	qqq++;
	for (int i = l; i < mid; i++) {
		if (v[i].first == -1) {
			used[v[i].second] = qqq;
		} 
	}
	vector<int> tmp = act;
	int pcnt = cnt;
	vector<int> nact;
	way.push_back(make_pair(-1, make_pair(-1, -1)));
	for (int i = 0; i < act.size(); i++) {
		if (used[act[i]] == qqq) {
			nact.push_back(act[i]);
		} else add(ss[act[i]], ff[act[i]]);
	}
	act = nact;
	solve(l, mid);
	cnt = pcnt;
	act = tmp;
	while (way.back().first != -1) {
		if (way.back().first == 0) {
			pred[way.back().second.first] = way.back().second.second;
		} else {
			rank[way.back().second.first] = way.back().second.second;	
		}
		way.pop_back();
	}
	way.pop_back();

	qqq++;
	for (int i = mid - 1; i >= l; i--) {
		if (v[i].first == -1) used[v[i].second] = qqq;
	}
	nact.clear();
	for (int i = 0; i < act.size(); i++) {
		if (used[act[i]] != qqq) nact.push_back(act[i]);
	}
	act = nact;
	nact.clear();

	qqq++;
	for (int i = 0; i < act.size(); i++) was[act[i]] = qqq;
	for (int i = mid - 1; i >= l; i--) {
		if (v[i].first == -1) {
			used[v[i].second] = qqq;
			continue;
		}
		if ((v[i].first == +1) && (qqq != used[v[i].second]) && (was[v[i].second] != qqq)) {
			act.push_back(v[i].second);
		}
	}
	nact.clear();
	qqq++;
	for (int i = mid; i < r; i++) {
		if (v[i].first == -1) {
			used[v[i].second] = qqq;
		}
	}
	way.push_back(make_pair(-1, make_pair(-1, -1)));
	for (int i = 0; i < act.size(); i++) {
		if (used[act[i]] == qqq) {
			nact.push_back(act[i]);
		} else add(ss[act[i]], ff[act[i]]);
	}
	act = nact;
	solve(mid, r);
	cnt = pcnt;
	act = tmp;
	while (way.back().first != -1) {
		if (way.back().first == 0) {
			pred[way.back().second.first] = way.back().second.second;
		} else {
			rank[way.back().second.first] = way.back().second.second;
		}
		way.pop_back();
	}
	way.pop_back();
}

int main() {
	freopen("disconnected.in", "r", stdin);
	scanf("%d%d", &n, &m);
	for (int i = 0; i < m; i++) {
		scanf("%d%d", &ss[i], &ff[i]);
		--ss[i];
		--ff[i];
	}
	for (int i = 0; i < m; i++) v.push_back(make_pair(+1, i));
	scanf("%d", &k);
	for (int i = 0; i < k; i++) {
		int kg;
		scanf("%d", &kg);
		vector<int> ve;
		for (int j = 0; j < kg; j++) {
			int x;
			scanf("%d", &x);
			--x;
			v.push_back(make_pair(-1, x));
			ve.push_back(x);
		}
		v.push_back(make_pair(0, i));
		for (int j = 0; j < ve.size(); j++) v.push_back(make_pair(+1, ve[j]));
	}
	for (int i = 0; i < n; i++) {
		pred[i] = i;
		rank[i] = 1;
	}	
	cnt = n;
//	for (int i = 0; i < v.size(); i++) cerr << v[i].first << " " << v[i].second << endl;
	solve(0, v.size());
	for (int i = 0; i < k; i++) {
		puts(ans[i] ? "Connected" : "Disconnected");
	}
}
