#include <iostream>
#include <cstdio>
#include <cstdlib>
using namespace std;
typedef pair<int, int> pii;
#define mp make_pair

const int MOD = 10007;
int a[MOD];
bool used[MOD][MOD];
int ans;
int n;
int nonzero;

int getNext(int x, int y)
{
	return (x * y) % MOD;
}

void dfs(int x0, int y0)
{
	int len = 2;
	a[x0]--; a[y0]--;
	if (a[x0] < 0 || a[y0] < 0)
	{
		a[x0]++;
		a[y0]++;
		return;
	}
	int x = x0, y = y0;
	while (!used[x0][y0])
	{
		used[x0][y0] = 1;
		while(true)
		{
			int nxt = getNext(x, y);
			if (a[nxt] <= 0)
				break;
			a[nxt]--;
			len++;
			x = y;
			y = nxt;
		}
		ans = max(ans, len);
		int nxt = getNext(x0, y0);
		a[x0]++;
		x0 = y0;
		y0 = nxt;
		len--;
		if (len < 2) break;
	}
	while(len > 0)
	{
		int nxt = getNext(x0, y0);
		a[x0]++;
		x0 = y0;
		y0 = nxt;
		len--;
	}
}

int main()
{
	freopen("death.in", "r", stdin);
	freopen("death.out", "w", stdout);

	scanf("%d", &n);
	while(n--)
	{
		int x;
		scanf("%d", &x);
		a[x]++;
		if (x == 0)
			ans++;
		else
			nonzero++;
	}

	if (nonzero != 0) ans++;
	ans = max(ans, 2);

	for (int x = 1; x < MOD; x++)
	{
		for (int y = 1; y < MOD; y++)
		{
			if (used[x][y]) continue;
			dfs(x, y);
		}
	}

	printf("%d\n", ans);

	return 0;
}